// Hotmail Watcher by Sonthakit Leelahanon
// Source Code License: GNU General Public License, version 3.0

var hotmailwatcherMain = {
	Active: false,
	TimerInterval: null,
	TimerTimeout: null,
	httpRequest: null,
	Branch: null,
	ObserveService: null,
	startup: function()
	{
		hotmailwatcherMain.TimerInterval = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		hotmailwatcherMain.TimerTimeout = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		hotmailwatcherMain.httpRequest = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		hotmailwatcherMain.Branch = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService).getBranch("extensions.hotmailwatcher.");
		hotmailwatcherMain.Branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
		// Preference adjust by version change
		if (hotmailwatcherMain.Branch.getIntPref("version")<111) {
			if (hotmailwatcherMain.Branch.getIntPref("interval")>6) {hotmailwatcherMain.Branch.setIntPref("interval", 6);}
		}
		if (hotmailwatcherMain.Branch.getIntPref("version")<130) {
			hotmailwatcherMain.Branch.setIntPref("interval", hotmailwatcherMain.Branch.getIntPref("interval")+4);
		}
		// First run or upgrade from version < 111
		if (hotmailwatcherMain.Branch.getIntPref("version")<111) {
			hotmailwatcherMain.Branch.setBoolPref("hidestatusbar",true);
			try {
				var myId = "hotmailwatcher-button";
				var navBar = document.getElementById("nav-bar");
				var curSet = navBar.currentSet.split(",");
				if (curSet.indexOf(myId) == -1) {
					var pos = curSet.length;
					var set = curSet.slice(0, pos).concat(myId).concat(curSet.slice(pos));
					navBar.setAttribute("currentset", set.join(","));
					navBar.currentSet = set.join(",");
					document.persist(navBar.id, "currentset");
					try {
						BrowserToolboxCustomizeDone(true);
					}		
					catch(e) {}
				}
			}
			catch(e) {}
		}
		hotmailwatcherMain.Branch.setIntPref("version", 131);
		hotmailwatcherMain.Branch.addObserver("", this, false);
		hotmailwatcherMain.ObserveService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
		hotmailwatcherMain.ObserveService.addObserver(this, "private-browsing", false);
		hotmailwatcherMain.ObserveService.addObserver(this, "hotmailwatcher_broadcast", false);
		if (Application.storage.get('hotmailwatcher_Status',"None")=="None") {
			Application.storage.set('hotmailwatcher_Status',"GNY");
			hotmailwatcherMain.Active = true;
			hotmailwatcherMain.ChangeStatus();
			if (hotmailwatcherMain.Branch.getIntPref("interval")<10) {
				var DelayFirstCheckingFor = hotmailwatcherMain.Branch.getIntPref("delayfirstcheckingfor");
				if (DelayFirstCheckingFor == 0) {
					hotmailwatcherMain.CheckNow();
				} else {
					var event = { notify: function(timer) { hotmailwatcherMain.CheckNow(); } }
					hotmailwatcherMain.TimerInterval.cancel();
					hotmailwatcherMain.TimerInterval.initWithCallback(event,DelayFirstCheckingFor*1000,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				}
			}
		} else {
			hotmailwatcherMain.ChangeStatus();
		}
	},
	CreatePopup: function()
	{
		if (hotmailwatcherMain.Branch.getBoolPref("sound")) {document.getElementById("hotmailwatcher-sound").setAttribute("checked", true);}
		if (hotmailwatcherMain.Branch.getBoolPref("display")) {document.getElementById("hotmailwatcher-display").setAttribute("checked", true);}
		if (hotmailwatcherMain.Branch.getBoolPref("blink")) {document.getElementById("hotmailwatcher-blink").setAttribute("checked", true);}
		document.getElementById("hotmailwatcher-Interval"+hotmailwatcherMain.Branch.getIntPref("interval")).setAttribute("checked", true);
		if( Application.storage.get('hotmailwatcher_Status',"").charAt(0)=="L" ) {
			document.getElementById("hotmailwatcher-CheckNow").setAttribute("disabled", true);
		} else {
			document.getElementById("hotmailwatcher-CheckNow").setAttribute("disabled", false);
		}
		return true;
	},
	CreateTooltip: function()
	{
		var Status = Application.storage.get('hotmailwatcher_Status',"");
		var TooltipText = 'Hotmail: ';
		if ( Status.charAt(0)=="L" ) {
			TooltipText = TooltipText + 'Loading...';
		} else {
			Status = Status.substr(2);
			switch (Status) {
				case "Y" :
					TooltipText = TooltipText + 'Not check yet';
					break;
				case "U" :
					TooltipText = TooltipText + 'Not connect';
					break;
				case "C" :
					TooltipText = TooltipText + 'Not connect';
					break;
				case "T" :
					TooltipText = TooltipText + 'Request timeout';
					break;
				case "L" :
					TooltipText = TooltipText + 'Log out';
					break;
				case "R" :
					TooltipText = TooltipText + 'Unread ()';
					break;
				default:
					TooltipText = TooltipText + 'Unread ('+Status+')';
					break;		
			}
		}
		document.getElementById("hotmailwatcher-tooltiptext").value = TooltipText;
		return true;
	},
	ChangeSound: function()
	{
		hotmailwatcherMain.Branch.setBoolPref("sound", document.getElementById("hotmailwatcher-sound").hasAttribute("checked"));
	},
	ChangeDisplay: function()
	{
		hotmailwatcherMain.Branch.setBoolPref("display", document.getElementById("hotmailwatcher-display").hasAttribute("checked"));
	},
	ChangeBlink: function()
	{
		hotmailwatcherMain.Branch.setBoolPref("blink", document.getElementById("hotmailwatcher-blink").hasAttribute("checked"));
	},
	ChangeInterval: function(NewInterval)
	{
		hotmailwatcherMain.Branch.setIntPref("interval", NewInterval);
	},
	ChangeTimer: function(NewInterval)
	{
		var event = { notify: function(timer) { hotmailwatcherMain.refreshInformation(); } }
		hotmailwatcherMain.TimerInterval.cancel();
		switch (NewInterval) {
			case 0:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,1*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 1:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,2*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 2:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,3*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 3:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,4*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 4:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,5*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 5:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,10*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 6:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,15*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 7:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,20*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 8:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,30*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 9:
				hotmailwatcherMain.TimerInterval.initWithCallback(event,60*60*1000,Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				break;
			case 10:
				break;
		}
	},
	About: function()
	{
		window.openDialog('chrome://hotmailwatcher/content/about.xul','','chrome,titlebar,toolbar,centerscreen,dialog=yes');
	},
	Advance: function()
	{
		window.openDialog('chrome://hotmailwatcher/content/options.xul','','chrome,titlebar,toolbar,centerscreen,dialog=yes');
	},
	Help: function()
	{
		var hotmailwatcherURL = 'chrome://hotmailwatcher/content/help.html';
		var urlbarvalue = document.getElementById('urlbar').value;
		urlbarvalue = urlbarvalue.replace(/^\s+|\s+$/g, '') ;
		if (urlbarvalue.length) {
			openUILinkIn(hotmailwatcherURL,'tab');
		} else {
			openUILinkIn(hotmailwatcherURL,'current');
		}
	},
	Feedback: function()
	{
		var hotmailwatcherURL = document.getElementById('hotmailwatcher-strings').getString('properties.hotmailwatcher.locale');
		hotmailwatcherURL = 'https://addons.mozilla.org/'+hotmailwatcherURL+'/firefox/addon/99015';
		var urlbarvalue = document.getElementById('urlbar').value;
		urlbarvalue = urlbarvalue.replace(/^\s+|\s+$/g, '') ;
		if (urlbarvalue.length) {
			openUILinkIn(hotmailwatcherURL,'tab');
		} else {
			openUILinkIn(hotmailwatcherURL,'current');
		}
	},
	hotmailwatcherClick: function(event)
	{
		if (event.detail==1) {
			if (event.button==0) {
				hotmailwatcherMain.OpenMail(); 
			} else if (event.button==1) {
				hotmailwatcherMain.CheckNow();
			}
		} 
	},
	OpenMail: function()
	{
		var urlbarvalue = document.getElementById('urlbar').value;
		urlbarvalue = urlbarvalue.replace(/^\s+|\s+$/g, '') ;
		if ((hotmailwatcherMain.Branch.getBoolPref("opennewtab")) && (urlbarvalue.length)) {
			openUILinkIn('http://mail.live.com','tab');
		} else {
			openUILinkIn('http://mail.live.com','current');
		}
		if (hotmailwatcherMain.Branch.getBoolPref("resetcounter")) {
			switch (Application.storage.get('hotmailwatcher_Status',"").charAt(0)) {
				case "C" :
					// not break
				case "B" :
					Application.storage.set('hotmailwatcher_Status',"CNR");
					hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
					break;
			}
		} else {
			if (Application.storage.get('hotmailwatcher_Status',"").charAt(0)=="B") {
				Application.storage.set('hotmailwatcher_Status',"CN"+Application.storage.get('hotmailwatcher_Status',"").substr(2));
				hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
			}
		}
	},
	CheckNow: function()
	{
		if ( Application.storage.get('hotmailwatcher_Status',"").charAt(0)!="L" ) {
			hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "CheckNow");
		}
	},
	refreshInformation: function()
	{
		Application.storage.set('hotmailwatcher_Status',"LN"+Application.storage.get('hotmailwatcher_Status',"").substr(2));
		hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
		hotmailwatcherMain.LoadStep = 1;
		hotmailwatcherMain.httpRequest.abort();
		// This old direct link to inbox still work which not depend on user opening homepage option between "window live home" or "inbox" 
		hotmailwatcherMain.httpRequest.open('GET', 'http://mail.live.com/?rru=inbox', true);
		hotmailwatcherMain.httpRequest.onload = hotmailwatcherMain.infoReceived;
		hotmailwatcherMain.httpRequest.onerror = hotmailwatcherMain.infoError;
		hotmailwatcherMain.httpRequest.send(null);
		var event = { notify: function(timer) { hotmailwatcherMain.infoTimeout(); } }
		hotmailwatcherMain.TimerTimeout.initWithCallback(event,50000,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},
	infoTimeout: function()
	{
		if( Application.storage.get('hotmailwatcher_Status',"").charAt(0)=="L" ) {
			hotmailwatcherMain.httpRequest.abort();
			Application.storage.set('hotmailwatcher_Status',"GNT");
			hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");	
		}
		hotmailwatcherMain.TimerTimeout.cancel();
	},
	infoError: function()
	{
		hotmailwatcherMain.TimerTimeout.cancel();
		Application.storage.set('hotmailwatcher_Status',"GNC");
		hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
		hotmailwatcherMain.httpRequest.abort();		// reset variable to decrease usage memory
	},
	infoReceived: function()
	{
		var output = hotmailwatcherMain.httpRequest.responseText;
		if (output.length)
		{
			if ((output.search('://login.live.com/login.srf') != -1) && (output.search('://login.live.com/jsDisabled.srf') != -1)) {
				Application.storage.set('hotmailwatcher_Status',"GNL");
			} else {
				var IsLog = output.search('id="00000000-0000-0000-0000-000000000001" nm="');
				if (IsLog == -1){
					output = output.replace(/&#47;/g, "/");
					output = output.replace(/&#58;/g, ":");
					output = output.replace(/&#61;/g, "=");
					output = output.replace(/&#63;/g, "?");
					IsLog = output.search('<iframe   id="UIFrame" name="UIFrame"  src="');									   
					if (IsLog != -1) {
						output = output.substr(IsLog+44);
						if (output.search('"') != -1) {
							output = output.split('"',1).toString();
							if (hotmailwatcherMain.LoadStep < 3) {
								hotmailwatcherMain.LoadStep = 3;
								hotmailwatcherMain.httpRequest.abort();
								hotmailwatcherMain.httpRequest.open('GET', output, true);
								hotmailwatcherMain.httpRequest.onload = hotmailwatcherMain.infoReceived;
								hotmailwatcherMain.httpRequest.onerror = hotmailwatcherMain.infoError;
								hotmailwatcherMain.httpRequest.send(null);
								return;
							}
						}
					} else {
						IsLog = output.search('window.location.replace');
						if (IsLog != -1) {
							output = output.substr(IsLog+25);
							if (output.search('"') != -1) {
								output = output.split('"',1).toString();
								if (hotmailwatcherMain.LoadStep < 2) {
									hotmailwatcherMain.LoadStep = 2;
									hotmailwatcherMain.httpRequest.abort();
									hotmailwatcherMain.httpRequest.open('GET', output, true);
									hotmailwatcherMain.httpRequest.onload = hotmailwatcherMain.infoReceived;
									hotmailwatcherMain.httpRequest.onerror = hotmailwatcherMain.infoError;
									hotmailwatcherMain.httpRequest.send(null);
									return;
								}
							}
						}
					}
					Application.storage.set('hotmailwatcher_Status',"GNU");
				} else {
					output = output.substr(IsLog+46);
					var mailcount = -1;
					IsLog = output.search('count="'); 
					if (IsLog != -1) {
						output = output.substr(IsLog+7);
						if (output.search('"') != -1) {
							output = output.split('"',1).toString();
							if (RegExp(/^\d{1,3}(,\d\d\d)*$|^\d+$/).test(output)) {
								output = output.replace(/,/g,"");
								mailcount = Number(output);
							}
						}
					}					
					if ((mailcount != -1) && (!hotmailwatcherMain.Branch.getBoolPref("inbox"))) {
						var output2 = "";
						var output3 = "";
						output = hotmailwatcherMain.httpRequest.responseText;
						IsLog = output.search('List FolderList');
						if (IsLog == -1) {
							mailcount = -1
						} else {
							output = output.substr(IsLog+15);
							if (output.search('AddFolderLight.aspx') == -1) {
							mailcount = -1
							} else {
								output = output.split('AddFolderLight.aspx',1).toString();
								IsLog = output.search(' id="');
								while (IsLog != -1) {
									output = output.substr(IsLog+5);
									if (output.search('" ') == -1) {
										mailcount = -1;
									} else {
										output2 = output.split('" ',1).toString();
										IsLog = output.search('count="');
										if (IsLog == -1) {
											mailcount = -1;
										} else {
											output = output.substr(IsLog+7);
											if (output.search('" ') == -1) {
												mailcount = -1;
											} else {
												output3 = output.split('" ',1).toString();
												if ((output2!='00000000-0000-0000-0000-000000000001') &&
													(output2!='00000000-0000-0000-0000-000000000005') &&
													(output2!='00000000-0000-0000-0000-000000000004') &&
													(output2!='00000000-0000-0000-0000-000000000003') &&
													(output2!='00000000-0000-0000-0000-000000000002')) {
													if (RegExp(/^\d{1,3}(,\d\d\d)*$|^\d+$/).test(output3)) {
														output3 = output3.replace(/,/g,'');
														mailcount = mailcount + Number(output3);
													} else {
														mailcount = -1;
													}
												}
											}
										}									
									}
									if (mailcount == -1) {IsLog = -1;} else {IsLog = output.search(' id="');}
								}
							}
						}
					}
					if (mailcount == -1) {
						Application.storage.set('hotmailwatcher_Status',"GNU");
					} else {
						if (mailcount == 0) {
							Application.storage.set('hotmailwatcher_Status',"CN0");
						} else {
							output = Application.storage.get('hotmailwatcher_Status',"").substr(2);
							IsLog = 0;
							if (!isNaN(Number(output))) {IsLog = Number(output);}
							if ((hotmailwatcherMain.Branch.getBoolPref("newlyarrived"))&&(mailcount <= IsLog)) {
								Application.storage.set('hotmailwatcher_Status',"CN"+mailcount.toString());
							} else {
								if (hotmailwatcherMain.Branch.getBoolPref("blink")) {
									Application.storage.set('hotmailwatcher_Status',"BA"+mailcount.toString());
								} else {
									Application.storage.set('hotmailwatcher_Status',"CA"+mailcount.toString());
								}
							}
						}
					}
				}
			}
		} else {
			Application.storage.set('hotmailwatcher_Status',"GNC");
		}
		//----------------------------------------------------------------------------------------------
		//	This part is for developer debugging of unknown new server response in the future
		//----------------------------------------------------------------------------------------------
		//	if (Application.storage.get('hotmailwatcher_Status',"")=="GNU") {
		//		output = hotmailwatcherMain.httpRequest.responseText;	
		//		if (output.search('Cache Access Denied')!=-1) { output="Recognized Unknown"; }
		//		if (output != "Recognized Unknown") {
		//			Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService)
		//				.logStringMessage('hotmailwatcher:\n'+Date()+'\n\n'+output);
		//			Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound).playSystemSound("_moz_alertdialog");
		//			Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService)
		//				.showAlertNotification(null, 'hotmailwatcher', 'Unknown Error Found', false, "", null);
		//		}
		//	}
		//----------------------------------------------------------------------------------------------
		//	End developer part
		//----------------------------------------------------------------------------------------------
		hotmailwatcherMain.TimerTimeout.cancel();
		hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
		hotmailwatcherMain.httpRequest.abort();		// reset variable to decrease usage memory
	},
	ChangeStatus: function ()
	{
		var Status = Application.storage.get('hotmailwatcher_Status',"");
		var StatusIcon = Status.charAt(0);
		var StatusAlert = Status.charAt(1);
		Status = Status.substr(2);
		if (hotmailwatcherMain.Branch.getBoolPref("hidestatusbar")) {
			document.getElementById("hotmailwatcher-panel").collapsed = true;
		} else {
			document.getElementById("hotmailwatcher-panel").collapsed = false;
			if ((StatusIcon!="L") || (!hotmailwatcherMain.Branch.getBoolPref("disableloadingicon"))) {
				document.getElementById('hotmailwatcher-image').src ='chrome://hotmailwatcher/skin/hotmailwatcher16'+StatusIcon+'.png';
			}
			var Label = document.getElementById('hotmailwatcher-label');
			switch (Status) {
				case "Y" :
				case "B" :
				case "U" :
				case "C" :
				case "T" :
				case "D" :
				case "L" :
					Label.value = '';
					Label.collapsed = true;
					break;
				case "R" :
					Label.value = '0';
					Label.collapsed = false;
					break;
				default:
					Label.value = Status;
					Label.collapsed = false;
					break;
			}
		}
		var MainWnd = document.getElementById("main-window");
		if (MainWnd) {
			if ((StatusIcon=="C") || (StatusIcon=="B")) {
				if (!isNaN(Number(Status))) { 
					if (hotmailwatcherMain.Branch.getBoolPref("showtoolbarnumber")) { 
						if (Number(Status)!=0) {
							if (Number(Status)<10) {
								StatusIcon = StatusIcon+Status;
							} else {
								StatusIcon = StatusIcon+'P';
							}
							StatusIcon = StatusIcon+"F"+hotmailwatcherMain.Branch.getIntPref("toolbarfont");
						}
					}
				}
			}
			if ((StatusIcon!="L") || (!hotmailwatcherMain.Branch.getBoolPref("disableloadingicon"))) {
				MainWnd.setAttribute("hotmailwatcher-buttontype",StatusIcon);
			}
		}
		if (StatusAlert=="A") {
			if (hotmailwatcherMain.Active) {
				if (hotmailwatcherMain.Branch.getBoolPref("sound")) {
					var hotmailwatcherSound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
					var hotmailwatcherIO = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
					switch (hotmailwatcherMain.Branch.getIntPref("soundtype")) {
						case 0:
							hotmailwatcherSound.play(hotmailwatcherIO.newURI('chrome://hotmailwatcher/content/newmail.wav', null, null));
							break;
						case 1:
							hotmailwatcherSound.playSystemSound("_moz_mailbeep");
							break;
						case 2:
							try {
								hotmailwatcherSound.play(hotmailwatcherIO.newFileURI(hotmailwatcherMain.Branch.getComplexValue("soundfile", Components.interfaces.nsILocalFile)));
							} catch(e) {
								try {
									var NewSoundFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
									var TextSoundFile = hotmailwatcherMain.Branch.getCharPref("soundfile");
									TextSoundFile = TextSoundFile.replace(/^\s+|\s+$/g, '');
									NewSoundFile.initWithPath(TextSoundFile);
									hotmailwatcherSound.play(hotmailwatcherOptionsIO.newFileURI(NewSoundFile));
								} catch(e) {
									Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService)
										.logStringMessage("Hotmail Watcher: Failure play custom sound file");
								}
							}
							break;
					}
				}
				var EmailName = 'Hotmail';
				if (hotmailwatcherMain.Branch.getBoolPref("display")) {
					StatusIcon = 'You have ' +Status+ ' unread '+ EmailName;
					if (Status != '1') {
						StatusIcon = StatusIcon+'s';
					}
					var listener = {
						observe: function(subject, topic, data) {
							if(topic == 'alertclickcallback') { hotmailwatcherMain.OpenMail(); }
						}
					}
					var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
					alertsService.showAlertNotification('chrome://hotmailwatcher/skin/hotmailwatcher32C.png', EmailName+' Watcher', StatusIcon, true, "", listener);
				}
			}
		}
	},
	observe: function(subject, topic, data)
	{
		if (topic == "nsPref:changed") {
			if (hotmailwatcherMain.Active) {
				var Status = Application.storage.get('hotmailwatcher_Status',"");
				switch (data) {
					case "interval" :
						hotmailwatcherMain.ChangeTimer(hotmailwatcherMain.Branch.getIntPref("interval"));
						break;
					case "blink" :
						if(hotmailwatcherMain.Branch.getBoolPref("blink")) {
							if (Status.charAt(0)=='C') {
								Status = Status.substr(2);
								switch (Status) {
									case "R" :
										break;
									case "0" :
										break;
									default:
										Application.storage.set('hotmailwatcher_Status',"BN"+Status);
										hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
										break;		
								}
							}
						} else {
							if (Status.charAt(0)=='B') {
								Application.storage.set('hotmailwatcher_Status',"CN"+Status.substr(2));
								hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
							}
						}
						break;
					case "showtoolbarnumber" :
						// not break
					case "hidestatusbar" :
						// not break
					case "toolbarfont" :
						Status = Status.charAt(0)+"N"+Status.substr(2);
						Application.storage.set('hotmailwatcher_Status',Status);
						hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
						break;
				}
			}
		} else if (topic == "private-browsing") {
			if (hotmailwatcherMain.Active) {
				if ((data == "enter")||(data == "exit")){
					Application.storage.set('hotmailwatcher_Status',"GNY");
					hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ChangeStatus");
					hotmailwatcherMain.httpRequest.abort();		// for privacy reason, reset hotmailwatcherMain.httpRequest.responseText to null
				}
			}
		} else if (topic == "hotmailwatcher_broadcast") {
			if (data=='ChangeStatus') {
				hotmailwatcherMain.ChangeStatus();
			} else if (hotmailwatcherMain.Active) {
				if (data=='CheckNow') {
					hotmailwatcherMain.TimerInterval.cancel();
					hotmailwatcherMain.refreshInformation();
					hotmailwatcherMain.ChangeTimer(hotmailwatcherMain.Branch.getIntPref("interval"));
				} else if (data=='ResetTimer') {
					hotmailwatcherMain.ChangeTimer(hotmailwatcherMain.Branch.getIntPref("interval"));
				}
			}
		}
	},
	shutdown: function()
	{
		hotmailwatcherMain.Branch.removeObserver("", this);
		hotmailwatcherMain.ObserveService.removeObserver(this, "private-browsing");
		hotmailwatcherMain.ObserveService.removeObserver(this, "hotmailwatcher_broadcast");
		hotmailwatcherMain.TimerInterval.cancel();
		hotmailwatcherMain.TimerTimeout.cancel();
		if (hotmailwatcherMain.Active) {
			var enumerator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator("navigator:browser"); 
			if (enumerator.hasMoreElements()) {
				enumerator.getNext().hotmailwatcherMain.Active = true;
				hotmailwatcherMain.ObserveService.notifyObservers(null, "hotmailwatcher_broadcast", "ResetTimer");
			} else {
				Application.storage.set('hotmailwatcher_Status',"None");
			}
		}
	}
}
window.addEventListener('load', function(e) { hotmailwatcherMain.startup(); }, false);
window.addEventListener('unload', function(e) { hotmailwatcherMain.shutdown(); }, false);