// Hotmail Watcher by Sonthakit Leelahanon
// Source Code License: GNU General Public License, version 3.0

var hotmailwatcherOptions = {
	Branch: null,
	LocalFileSound: null,
	LocalFileSoundValid: true,
	Init: function() {
		hotmailwatcherOptions.Branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.hotmailwatcher.");
		try {
			hotmailwatcherOptions.LocalFileSound = hotmailwatcherOptions.Branch.getComplexValue("soundfile", Components.interfaces.nsILocalFile);
			document.getElementById("hotmailwatcher-options-soundfile").value = hotmailwatcherOptions.LocalFileSound.path;
		} catch(e) {
			hotmailwatcherOptions.LocalFileSoundValid = false;
			document.getElementById("hotmailwatcher-options-soundfile").value = hotmailwatcherOptions.Branch.getCharPref("soundfile");			
		}
		document.getElementById("hotmailwatcher-options-interval").value = hotmailwatcherOptions.Branch.getIntPref("interval");
		hotmailwatcherOptions.ScaleChange();
		hotmailwatcherOptions.SoundChange(-1);
	},
	ScaleChange: function() {
		switch (document.getElementById("hotmailwatcher-options-interval").value) {
			case 0:
				document.getElementById("hotmailwatcher-options-label").value="1 minute";
				break;
			case 1:
				document.getElementById("hotmailwatcher-options-label").value="2 minutes";
				break;
			case 2:
				document.getElementById("hotmailwatcher-options-label").value="3 minutes";
				break;
			case 3:
				document.getElementById("hotmailwatcher-options-label").value="4 minutes";
				break;
			case 4:
				document.getElementById("hotmailwatcher-options-label").value="5 minutes";
				break;
			case 5:
				document.getElementById("hotmailwatcher-options-label").value="10 minutes";
				break;
			case 6:
				document.getElementById("hotmailwatcher-options-label").value="15 minutes";
				break;
			case 7:
				document.getElementById("hotmailwatcher-options-label").value="20 minutes";
				break;
			case 8:
				document.getElementById("hotmailwatcher-options-label").value="30 minutes";
				break;
			case 9:
				document.getElementById("hotmailwatcher-options-label").value="1 hour";
				break;
			case 10:
				document.getElementById("hotmailwatcher-options-label").value="No Auto Check";
				break;
		}
	},
	Help: function()
	{
		var hotmailwatcheroptionsURL = 'chrome://hotmailwatcher/content/help.html';
		var recentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator)
					.getMostRecentWindow("navigator:browser");
		if (recentWindow)
		{
			var urlbarvalue = recentWindow.document.getElementById('urlbar').value;
			urlbarvalue = urlbarvalue.replace(/^\s+|\s+$/g, '') ;
			if (urlbarvalue.length) {
				recentWindow.delayedOpenTab(hotmailwatcheroptionsURL);
			} else {
				recentWindow.loadURI(hotmailwatcheroptionsURL);
			}
		} else {
			window.open(hotmailwatcheroptionsURL);
		}
	},
	OpenSoundFile: function()
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Select wav File", nsIFilePicker.modeOpen);
		fp.appendFilter("Wav Files","*.wav");
		if (fp.show() == nsIFilePicker.returnOK) {
			hotmailwatcherOptions.LocalFileSound = fp.file;
			hotmailwatcherOptions.LocalFileSoundValid = true;
			document.getElementById("hotmailwatcher-options-soundfile").value = hotmailwatcherOptions.LocalFileSound.path;
			document.getElementById("hotmailwatcher-options-groupsound").selectedIndex=2;
			if (Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("browser.preferences.instantApply")) {
				hotmailwatcherOptions.SaveSoundFile();
			}
		}
	},
	TestSound: function()
	{
		var hotmailwatcherOptionsSound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
		var hotmailwatcherOptionsIO = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		switch (document.getElementById("hotmailwatcher-options-groupsound").selectedIndex) {
			case 0:
				hotmailwatcherOptionsSound.play(hotmailwatcherOptionsIO.newURI('chrome://hotmailwatcher/content/newmail.wav', null, null));
				break;
			case 1:
				hotmailwatcherOptionsSound.playSystemSound("_moz_mailbeep");
				break;
			case 2:
				var NewSoundFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				var TextSoundFile = document.getElementById("hotmailwatcher-options-soundfile").value;
				TextSoundFile = TextSoundFile.replace(/^\s+|\s+$/g, '') ;
				try {
					if (hotmailwatcherOptions.LocalFileSoundValid) {
						if (hotmailwatcherOptions.LocalFileSound.path == TextSoundFile) {
							hotmailwatcherOptionsSound.play(hotmailwatcherOptionsIO.newFileURI(hotmailwatcherOptions.LocalFileSound));
						} else {
							NewSoundFile.initWithPath(TextSoundFile);
							hotmailwatcherOptionsSound.play(hotmailwatcherOptionsIO.newFileURI(NewSoundFile));  
						}
					} else {
						NewSoundFile.initWithPath(TextSoundFile);
						hotmailwatcherOptionsSound.play(hotmailwatcherOptionsIO.newFileURI(NewSoundFile));  
					}
				} catch(e) {
				}
				break;
		}
	},
	SoundChange: function(soundtype)
	{
		if (soundtype== -1) {soundtype = document.getElementById("hotmailwatcher-options-groupsound").selectedIndex;}
		if (soundtype== 2) {
			document.getElementById("hotmailwatcher-options-openfile").disabled = false;
			document.getElementById("hotmailwatcher-options-soundfile").disabled = false;
		} else {
			document.getElementById("hotmailwatcher-options-openfile").disabled = true;
			document.getElementById("hotmailwatcher-options-soundfile").disabled = true;
		}
	},
	SoundFileTextboxChange: function()
	{
		if (Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("browser.preferences.instantApply")) {
			hotmailwatcherOptions.SaveSoundFile();
		}
	},
	SaveSoundFile: function()
	{
		var NewSoundFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var TextSoundFile = document.getElementById("hotmailwatcher-options-soundfile").value;
		TextSoundFile = TextSoundFile.replace(/^\s+|\s+$/g, '') ;
		try {
			if (hotmailwatcherOptions.LocalFileSoundValid) {
				if (hotmailwatcherOptions.LocalFileSound.path == TextSoundFile) {
					hotmailwatcherOptions.Branch.setComplexValue("soundfile", Components.interfaces.nsILocalFile, hotmailwatcherOptions.LocalFileSound);
				} else {
					NewSoundFile.initWithPath(TextSoundFile);
					hotmailwatcherOptions.Branch.setComplexValue("soundfile", Components.interfaces.nsILocalFile, NewSoundFile);
				}
			} else {
				NewSoundFile.initWithPath(TextSoundFile);
				hotmailwatcherOptions.Branch.setComplexValue("soundfile", Components.interfaces.nsILocalFile, NewSoundFile);
			}
		} catch(e) {
			hotmailwatcherOptions.Branch.setCharPref("soundfile", TextSoundFile);
		}
	},
	Accept: function()
	{
		hotmailwatcherOptions.SaveSoundFile();
		return true;
	},
}
